
import pandas as pd
import unittest
import movies

class LoadTests(unittest.TestCase):
    """Test functions concerned with loading and preparing the dataset"""

    @staticmethod
    def toy_ratings():
        """Return a toy dataframe with ratings"""
        return pd.DataFrame(data={
            "userId": [1, 1, 2, 2, 1],
            "movieId": [1, 2, 1, 3, 4],
            "rating": [3, 1, 4, 3, 5],
            "timestamp": [1, 2, 7, 5, 4],
        },
        columns=["userId", "movieId", "rating", "timestamp"])
    
    def test_collect_user_context(self):
        """Check that ratings are correctly aggregated"""
        rating = self.toy_ratings()
        user_movies = movies.collect_user_context(rating)
        
        self.assertEqual(user_movies[1], [1, 4]) 
        self.assertEqual(user_movies[2], [3, 1]) 
        self.assertEqual(set(user_movies.keys()), {1, 2})

